package com.loafle.overflow.module.discovery.service;

import com.loafle.overflow.commons.model.SessionMetadata;
import com.loafle.overflow.commons.service.MessagePublisher;
import com.loafle.overflow.commons.stereotype.ProbeAPI;
import com.loafle.overflow.commons.stereotype.WebappAPI;
import com.loafle.overflow.module.discovery.model.DiscoveryHost;
import com.loafle.overflow.module.discovery.model.DiscoveryPort;
import com.loafle.overflow.module.discovery.model.DiscoveryStartInfo;
import com.loafle.overflow.module.discovery.model.DiscoveryZone;
import com.loafle.overflow.module.discovery.model.Host;
import com.loafle.overflow.module.discovery.model.Port;
import com.loafle.overflow.module.discovery.model.Zone;
import com.loafle.overflow.module.domain.model.Domain;
import org.codehaus.jackson.map.ObjectMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.io.IOException;

/**
 * Created by snoop on 17. 9. 28.
 */
@Service("DiscoveryService")
public class DiscoveryService {

    @Autowired
    private MessagePublisher messagePublisher;

    public void startDiscovery(DiscoveryStartInfo startInfo) throws IOException {

        ObjectMapper objectMapper = new ObjectMapper();

        String json = objectMapper.writeValueAsString(startInfo);

        System.out.println("Start Discovery");
        System.out.println(json);
//        this.messagePublisher.publishToProbe("/auth", noAuthProbe.getTempProbeKey(), "NoAuthProbeService.acceptNoAuthProbe", probe.getProbeKey());
    }

    public boolean testDiscovery(int types, String obj) {

        Domain domain = new Domain();
        domain.setId(1);

//        int typeInt = Integer.valueOf(types);
        switch (types) {
            case 1 :
                messagePublisher.publishToDomain("/webapp", domain, "DiscoveryService.discoveryIngHost", obj);
                break;
            case 2 :
                messagePublisher.publishToDomain("/webapp", domain, "DiscoveryService.discoveryIngPort", obj);
                break;
            case 3 :
                messagePublisher.publishToDomain("/webapp", domain, "DiscoveryService.discoveryIngService", obj);
                break;
        }


        return true;
		}
		
		@WebappAPI
		public void discoverZone(String probeID, DiscoveryZone discoveryZone) {
			String requestMemberEmail = SessionMetadata.getSessionID();
	
			messagePublisher.publishToProbe("/probe", probeID, "DiscoveryService.DiscoverZone", requestMemberEmail, discoveryZone);
		}
	
		@WebappAPI
		public void discoverHost(String probeID, Zone zone, DiscoveryHost discoveryHost) {
			String requestMemberEmail = SessionMetadata.getSessionID();
	
			messagePublisher.publishToProbe("/probe", probeID, "DiscoveryService.DiscoverHost", requestMemberEmail, zone, discoveryHost);
		}
	
		@WebappAPI
		public void discoverPort(String probeID, Host host, DiscoveryPort discoveryPort) {
			String requestMemberEmail = SessionMetadata.getSessionID();
	
			messagePublisher.publishToProbe("/probe", probeID, "DiscoveryService.DiscoverPort", requestMemberEmail, host, discoveryPort);
		}
	
		@WebappAPI
		public void discoverService(String probeID, Port port, com.loafle.overflow.module.discovery.model.DiscoveryService discoveryService) {
			String requestMemberEmail = SessionMetadata.getSessionID();
	
			messagePublisher.publishToProbe("/probe", probeID, "DiscoveryService.DiscoverService", requestMemberEmail, port, discoveryService);
		}
	
	
		@ProbeAPI
		public void discoveredZone(String requestMemberEmail, Zone zone) {
			messagePublisher.publishToMember("/webapp", requestMemberEmail, "DiscoveryService.discoveredZone", zone);			
		}
	
		@ProbeAPI
		public void discoveredHost(String requestMemberEmail, Host host) {
			messagePublisher.publishToMember("/webapp", requestMemberEmail, "DiscoveryService.discoveredHost", host);			
		}
	
		@ProbeAPI
		public void discoveredPort(String requestMemberEmail, Port port) {
			messagePublisher.publishToMember("/webapp", requestMemberEmail, "DiscoveryService.discoveredPort", port);			
		}
	
		@ProbeAPI
		public void discoveredService(String requestMemberEmail, com.loafle.overflow.module.discovery.model.Service service) {
			messagePublisher.publishToMember("/webapp", requestMemberEmail, "DiscoveryService.discoveredService", service);			
		}
	
}